Coin: SoSensorManager Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | List of all members
SoSensorManager Class Reference
Sensor Classes

The SoSensorManager class handles the sensor queues. More...

`#include <Inventor/sensors/SoSensorManager.h>`

## Public Member Functions
| SoSensorManager (void)
| ~SoSensorManager ()
void | insertDelaySensor (SoDelayQueueSensor *s)
void | insertTimerSensor (SoTimerQueueSensor *s)
void | removeDelaySensor (SoDelayQueueSensor *s)
void | removeTimerSensor (SoTimerQueueSensor *s)
void | setChangedCallback (void(*sensorQueueChangedCB)(void *), void *data)
void | rescheduleTimer (SoTimerSensor *s)
void | removeRescheduledTimer (SoTimerQueueSensor *s)
void | processDelayQueue (SbBool isidle)
void | processImmediateQueue (void)
void | processTimerQueue (void)
SbBool | isDelaySensorPending (void)
SbBool | isTimerSensorPending (SbTime &tm)
void | setDelaySensorTimeout (const SbTime &t)
const SbTime & | getDelaySensorTimeout (void)
int | doSelect (int nfds, void *readfds, void *writefds, void *exceptfds, struct timeval *userTimeOut)

## Detailed Description

The SoSensorManager class handles the sensor queues.

There are two major sensor types in Coin, "delay" sensors and "timer" sensors:

- Delay sensors trigger when the application is otherwise idle. In addition, to avoid starvation in applications that are continually busy, the delay sensor queue also has a timeout which, when reached, will empty the queue anyhow.

- Timer sensors are set up to trigger at specific, absolute times.

Each of these two types has its own queue, which is handled by the SoSensorManager. The queues are kept in sorted order by SoSensorManager, either according to trigger time (for timer sensors) or by priority (for delay sensors).

The SoSensorManager provides methods for managing these queues, by insertion and removal of sensors, and processing (emptying) of the queues.

The sensor mechanism is crucial in Coin for a number of important features, most notably automatic scheduling redraw upon changes, and for making it possible to set up animations in the scene graph which does not need any additional book-keeping from the application code.

SoSensorManager should usually be considered as an internal class in the Coin API. It is only interesting for application programmers when implementing new window system specific libraries (like Kongsberg Oil & Gas Technologies SoQt, SoXt, SoGtk, SoWin or Sc21) or wrappers. Then one has to set up code to empty the queues at the correct intervals. For detailed information on how to do that, we would advise you to look at the implementation of said mechanisms in the So*-libraries which SIM provides.

Please note that before Coin 2.3.1, sensors with equal priority (or the same trigger time for SoTimerQueue sensors) were processed LIFO. This has now been changed to FIFO to be conformant to SGI Inventor.

See also
  SoSensor SoTimerQueueSensor SoDelayQueueSensor
  SoTimerSensor SoAlarmSensor
  SoIdleSensor SoDataSensor SoOneShotSensor
  SoPathSensor SoFieldSensor SoNodeSensor

## Constructor & Destructor Documentation

## ◆ SoSensorManager()

SoSensorManager::SoSensorManager | ( | void |  | ) |

Constructor.

## ◆ ~SoSensorManager()

SoSensorManager::~SoSensorManager | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ insertDelaySensor()

void SoSensorManager::insertDelaySensor | ( | SoDelayQueueSensor * | newentry | ) |

Add a new entry to the queue of delay sensors.

See also
  removeFromQueue()

## ◆ insertTimerSensor()

void SoSensorManager::insertTimerSensor | ( | SoTimerQueueSensor * | newentry | ) |

Add a new entry to the queue of timer sensors. The queue will be sorted in order of supposed trigger time.

See also
  removeFromQueue()

## ◆ removeDelaySensor()

void SoSensorManager::removeDelaySensor | ( | SoDelayQueueSensor * | entry | ) |

Remove an entry from the queue of prioritized sensors.

See also
  addToQueue()

## ◆ removeTimerSensor()

void SoSensorManager::removeTimerSensor | ( | SoTimerQueueSensor * | entry | ) |

Remove an entry from the queue of timer sensors.

## ◆ setChangedCallback()

void SoSensorManager::setChangedCallback | ( | void(* | func )(void *),
|  | void * | data )

For setting up a callback function to be invoked whenever any of the sensor queues are changed.

This callback should typically be responsible for updating the client-side mechanism which is used for processing the queues.

## ◆ rescheduleTimer()

void SoSensorManager::rescheduleTimer | ( | SoTimerSensor * | s | ) |

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ removeRescheduledTimer()

void SoSensorManager::removeRescheduledTimer | ( | SoTimerQueueSensor * | s | ) |

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ processDelayQueue()

void SoSensorManager::processDelayQueue | ( | SbBool | isidle | ) |

Trigger all delay queue entries in priority order.

The isidle flag indicates whether or not the processing happens because the application is idle or because the delay queue timeout was reached.

A delay queue sensor with priority > 0 can only be triggered once during a call to this function. If a delay sensor is rescheduled during processDelayQueue(), it is not processed until the next time this function is called. This is done to avoid an infinite loop while processing the sensors.

A delay queue sensor with priority 0 is called an immediate sensor.

See also
  SoDB::setDelaySensorTimeout()
  SoSensorManager::processImmediateQueue()

## ◆ processImmediateQueue()

void SoSensorManager::processImmediateQueue | ( | void |  | ) |

Process all immediate sensors (delay sensors with priority 0).

Be aware that you might risk an infinite loop using immediate sensors. Unlike delay queue sensors, immediate sensors can be rescheduled and triggered multiple times during immediate queue processing.

See also
  SoDelayQueueSensor::setPriority()

## ◆ processTimerQueue()

void SoSensorManager::processTimerQueue | ( | void |  | ) |

Trigger all the timers which have expired.

## ◆ isDelaySensorPending()

SbBool SoSensorManager::isDelaySensorPending | ( | void |  | ) |

Returns `TRUE` if at least one delay sensor or immediate sensor is present in the respective queue, otherwise `FALSE`.

## ◆ isTimerSensorPending()

SbBool SoSensorManager::isTimerSensorPending | ( | SbTime & | tm | ) |

Returns `TRUE` if at least one timer sensor is present in the queue, otherwise `FALSE`.

If sensors are pending, the time interval until the next one should be triggered will be put in the tm variable.

## ◆ setDelaySensorTimeout()

void SoSensorManager::setDelaySensorTimeout | ( | const SbTime & | t | ) |

Delay sensors are usually triggered only when the system is idle. But when there are continuous updates to the scene graph, there's a possibility that the delay queue will starve and sensors are never triggered. To make sure this won't happen, this is a timeout value for the delay queue. When this timeout has been reached, the sensors in the delay queue gets processed before other sensors and events. This method will let the user set this timeout value.

The default value is 1/12 of a second.

Specifying a zero time will disable the timeout, opening for potential delay queue starvation.

See also
  getDelaySensorTimeout(), SoDelayQueueSensor

## ◆ getDelaySensorTimeout()

const SbTime & SoSensorManager::getDelaySensorTimeout | ( | void |  | ) |

Returns the timeout value for sensors in the delay queue.

See also
  setDelaySensorTimeout(), SoDelayQueueSensor

## ◆ doSelect()

int SoSensorManager::doSelect | ( | int | nfds,
|  | void * | readfds,
|  | void * | writefds,
|  | void * | exceptfds,
|  | struct timeval * | usertimeout )

NOTE: THIS METHOD IS OBSOLETED. DON'T USE IT.

This is a wrapper around the standard select(2) call, which will make sure the sensor queues are updated while waiting for any action to happen on the given file descriptors.

The void* arguments must be valid pointers to fd_set structures. We've changed this from the original SGI Inventor API to avoid messing up the header file with system specific includes.

NOTE: THIS METHOD IS OBSOLETED. DON'T USE IT.

The documentation for this class was generated from the following files:

- SoSensorManager.h
- SoSensorManager.cpp